// Copyright (2013) Jann Horn <jann@thejh.net>
// This code is licensed under the AGPLv3.

#include <string.h>

HEADER #define streq(a,b) (!strcmp((a),(b)))

PUBLIC_FN int count_char_occurences(char *s, char c) {
  int n=0;
  while (*s) {
    if (*s==c) n++;
    s++;
  }
  return n;
}

// memcpy plus terminating nullbyte
PUBLIC_FN void *memcpyn(void *d, const void *s, size_t n) {
  memcpy(d, s, n);
  char *d_ = d;
  d_[n] = '\0';
  return d;
}

// Wipe out whitespace characters at the end of str using nullbytes.
PUBLIC_FN void trim_end(char *str, char *whitespace) {
  for (char *p = str+strlen(str)-1; p>=str; p--) {
    if (!strchr(whitespace, *p)) break;
    *p = '\0';
    p--;
  }
}

PUBLIC_FN int ends_with(char *str, char *sub) {
  size_t str_len = strlen(str);
  size_t sub_len = strlen(sub);
  if (sub_len>str_len) return 0;
  return streq(str+str_len-sub_len, sub);
}
